Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -2440,83 +2228,55 @@
  * Returns:
  *      0 = firmware does not need to be loaded.
  */
-STATIC uint8_t
-qla1280_isp_firmware(scsi_qla_host_t *ha)
+static int
+qla1280_isp_firmware(struct scsi_qla_host *ha)
 {
-    nvram_t     *nv    = (nvram_t *)ha->response_ring; 
-    uint16_t    *wptr;
-    uint8_t     chksum;
-    uint8_t     cnt;
-    uint8_t     status = 0;    /* dg 2/27 always loads RISC */
-    uint16_t    mb[MAILBOX_REGISTER_COUNT];
-
-    ENTER("qla1280_isp_firmware");
-
-    /* Verify valid NVRAM checksum. */
-    wptr = (uint16_t *)ha->response_ring;
-    DEBUG(printk("qla1280_isp_firmware: Reading NVRAM\n"));
-    chksum = 0;
-    for (cnt = 0; cnt < sizeof(nvram_t)/2; cnt++)
-    {
-        *wptr = qla1280_get_nvram_word(ha, cnt);
-        chksum += (uint8_t)*wptr;
-        chksum += (uint8_t)(*wptr >> 8);
-        wptr++;
-    }
-    DEBUG(printk("qla1280_isp_firmware: Completed Reading NVRAM\n"));
-
-#if defined(QL_DEBUG_LEVEL_3)
-    sprintf(debug_buff,"qla1280_isp_firmware: NVRAM Magic ID= %c %c %c\n\r",(char *) nv->id[0],nv->id[1],nv->id[2]);
-    qla1280_print(debug_buff);
-#endif
-
-    /* Bad NVRAM data, load RISC code. */
-    if (chksum || nv->id[0] != 'I' || nv->id[1] != 'S' ||
-        nv->id[2] != 'P' || nv->id[3] != ' ' || nv->version < 1)
-    {
-        printk(KERN_INFO "qla1280_isp_firmware: Bad checksum or magic number or version in NVRAM.\n");
-        ha->flags.disable_risc_code_load = FALSE;
-    }
-    else
-        ha->flags.disable_risc_code_load = nv->cntr_flags_1.disable_loading_risc_code;
-
-    if (ha->flags.disable_risc_code_load)
-    {
-#if defined(QL_DEBUG_LEVEL_3)
-        qla1280_print("qla1280_isp_firmware: Telling RISC to verify checksum of loaded BIOS code.\n\r");
-#endif
-        /* Verify checksum of loaded RISC code. */
-        mb[0] = MBC_VERIFY_CHECKSUM;
-        /* mb[1] = ql12_risc_code_addr01; */
-        mb[1] = *QLBoardTbl[ha->devnum].fwstart;  
-
-        if (!(status = qla1280_mailbox_command(ha, BIT_1|BIT_0, &mb[0])))
-        {
-            /* Start firmware execution. */
-#if defined(QL_DEBUG_LEVEL_3)
-            qla1280_print("qla1280_isp_firmware: Startng F/W execution.\n\r");
-#endif
-            mb[0] = MBC_EXECUTE_FIRMWARE;
-            /* mb[1] = ql12_risc_code_addr01; */
-            mb[1] = *QLBoardTbl[ha->devnum].fwstart;  
-            qla1280_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
-        }
-        else
-            printk(KERN_INFO "qla1280: RISC checksum failed.\n");
-    }
-    else
-    {
-        DEBUG(printk("qla1280: NVRAM configured to load RISC load.\n"));
-        status = 1;
-     }
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (status)
-        qla1280_print(
-                "qla1280_isp_firmware: **** Load RISC code ****\n\r");
-#endif
-    LEAVE("qla1280_isp_firmware");
-    return(status);
+	struct nvram *nv = (struct nvram *) ha->response_ring;
+	int status = 0;		/* dg 2/27 always loads RISC */
+	uint16_t mb[MAILBOX_REGISTER_COUNT];
+
+	ENTER("qla1280_isp_firmware");
+
+	dprintk(1, "scsi(%li): Determining if RISC is loaded\n", ha->host_no);
+
+	/* Bad NVRAM data, load RISC code. */
+	if (!ha->nvram_valid) {
+		ha->flags.disable_risc_code_load = 0;
+	} else
+		ha->flags.disable_risc_code_load =
+			nv->cntr_flags_1.disable_loading_risc_code;
+
+	if (ha->flags.disable_risc_code_load) {
+		dprintk(3, "qla1280_isp_firmware: Telling RISC to verify "
+			"checksum of loaded BIOS code.\n");
+
+		/* Verify checksum of loaded RISC code. */
+		mb[0] = MBC_VERIFY_CHECKSUM;
+		/* mb[1] = ql12_risc_code_addr01; */
+		mb[1] = *ql1280_board_tbl[ha->devnum].fwstart;
+
+		if (!(status =
+		      qla1280_mailbox_command(ha, BIT_1 | BIT_0, &mb[0]))) {
+			/* Start firmware execution. */
+			dprintk(3, "qla1280_isp_firmware: Startng F/W "
+				"execution.\n");
+
+			mb[0] = MBC_EXECUTE_FIRMWARE;
+			/* mb[1] = ql12_risc_code_addr01; */
+			mb[1] = *ql1280_board_tbl[ha->devnum].fwstart;
+			qla1280_mailbox_command(ha, BIT_1 | BIT_0, &mb[0]);
+		} else
+			printk(KERN_INFO "qla1280: RISC checksum failed.\n");
+	} else {
+		dprintk(1, "qla1280: NVRAM configured to load RISC load.\n");
+		status = 1;
+	}
+
+	if (status)
+		dprintk(2, "qla1280_isp_firmware: **** Load RISC code ****\n");
+
+	LEAVE("qla1280_isp_firmware");
+	return status;
 }
 
 /*
@@ -2529,75 +2289,60 @@
  * Returns:
  *      0 = success.
  */
-STATIC uint8_t
-qla1280_pci_config(scsi_qla_host_t *ha)
+static int
+qla1280_pci_config(struct scsi_qla_host *ha)
 {
-    uint8_t      status = 1;
-    uint32_t     command;
 #if MEMORY_MAPPED_IO
-    uint32_t  page_offset, base;
-    uint32_t   mmapbase;
+	unsigned long base;
+	int size;
 #endif
-    config_reg_t *creg = 0;
-    uint16_t     buf_wd;
+	uint16_t buf_wd;
+	int status = 1;
 
-    ENTER("qla1280_pci_config");
+	ENTER("qla1280_pci_config");
 
-    /* Get command register. */
-    if (pci_read_config_word(ha->pdev,OFFSET(creg->command), &buf_wd) == PCIBIOS_SUCCESSFUL)
-    {
-        command = buf_wd;
-        /*
-        * Set Bus Master Enable, Memory Address Space Enable and
-        * reset any error bits.
-        */
-        buf_wd &= ~0x7;
+	pci_set_master(ha->pdev);
+	/*
+	 * Set Bus Master Enable, Memory Address Space Enable and
+	 * reset any error bits, in the command register.
+	 */
+	pci_read_config_word (ha->pdev, PCI_COMMAND, &buf_wd);
 #if MEMORY_MAPPED_IO
-        DEBUG(printk("qla1280: MEMORY MAPPED IO is enabled.\n"));
-        buf_wd |= BIT_2 + BIT_1 + BIT_0;
-#else
-        buf_wd |= BIT_2 + BIT_0;
+	buf_wd |= PCI_COMMAND_MEMORY;
 #endif
-        if( pci_write_config_word(ha->pdev,OFFSET(creg->command), buf_wd) )
-        {
-            printk(KERN_WARNING "qla1280: Could not write config word.\n");
-        }
-        /* Get expansion ROM address. */
-        if (pci_read_config_word(ha->pdev,OFFSET(creg->expansion_rom), &buf_wd) == PCIBIOS_SUCCESSFUL)
-        {
-            /* Reset expansion ROM address decode enable. */
-            buf_wd &= ~BIT_0;
-            if (pci_write_config_word(ha->pdev,OFFSET(creg->expansion_rom), buf_wd) == PCIBIOS_SUCCESSFUL)
-            {
+	buf_wd |= PCI_COMMAND_IO;
+	pci_write_config_word (ha->pdev, PCI_COMMAND, buf_wd);
+	/*
+	 * Reset expansion ROM address decode enable.
+	 */
+	pci_read_config_word(ha->pdev, PCI_ROM_ADDRESS, &buf_wd);
+	buf_wd &= ~PCI_ROM_ADDRESS_ENABLE;
+	pci_write_config_word (ha->pdev, PCI_ROM_ADDRESS, buf_wd);
+
+	ha->host->io_port = pci_resource_start(ha->pdev, 0);
+	ha->host->io_port &= PCI_BASE_ADDRESS_IO_MASK;
+	ha->iobase = (struct device_reg *) ha->host->io_port;
+
 #if MEMORY_MAPPED_IO
-                /* Get memory mapped I/O address. */
-                pci_read_config_dword(ha->pdev,OFFSET(cfgp->mem_base_addr), &mmapbase);
-                mmapbase &= PCI_BASE_ADDRESS_MEM_MASK;
-
-                /* Find proper memory chunk for memory map I/O reg. */
-                base = mmapbase & PAGE_MASK;
-                page_offset = mmapbase - base;
-                /* Get virtual address for I/O registers. */
-#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,0)
-                ha->mmpbase = ioremap_nocache(base, page_offset + 256);
-#else
-                ha->mmpbase = vremap(base,page_offset + 256);
-#endif
-                if( ha->mmpbase )
-                {
-                    ha->mmpbase += page_offset;
-                    /* ha->iobase = ha->mmpbase; */
-                    status = 0;
-                }
-#else /* MEMORY_MAPPED_IO */
-                status = 0;
-#endif /* MEMORY_MAPPED_IO */
-            }
-        }
-    }
+	/*
+	 * Find proper memory chunk for memory map I/O reg.
+	 */
+	base = pci_resource_start(ha->pdev, 1);
+	size = pci_resource_len(ha->pdev, 1);
+	/*
+	 * Get virtual address for I/O registers.
+	 */
+	ha->mmpbase = ioremap(base, size);
+	if (ha->mmpbase) {
+		ha->iobase = (struct device_reg *)ha->mmpbase;
+		status = 0;
+	}
+#else				/* MEMORY_MAPPED_IO */
+	status = 0;
+#endif				/* MEMORY_MAPPED_IO */
 
-    LEAVE("qla1280_pci_config");
-    return(status);
+	LEAVE("qla1280_pci_config");
+	return status;
 }
 
 /*
@@ -2610,109 +2355,129 @@
  * Returns:
  *      0 = success.
  */
-STATIC uint8_t
-qla1280_chip_diag(scsi_qla_host_t *ha)
+static int
+qla1280_chip_diag(struct scsi_qla_host *ha)
 {
-    device_reg_t *reg   = ha->iobase;
-    uint8_t      status = 0;
-    uint16_t     data;
-    uint32_t     cnt;
-    uint16_t     mb[MAILBOX_REGISTER_COUNT];
-
-#ifdef QL_DEBUG_LEVEL_3
-    sprintf(debug_buff, "qla1280_chip_diag: testing device at 0x%p \n\r",&reg->id_l);
-    qla1280_print(debug_buff);
-#endif
-
-    /* Soft reset chip and wait for it to finish. */
-    WRT_REG_WORD(&reg->ictrl, ISP_RESET); 
-    data = qla1280_debounce_register(&reg->ictrl);
-    for (cnt = 6000000; cnt && data & ISP_RESET; cnt--)
-    {
-        SYS_DELAY(5);
-        data = RD_REG_WORD(&reg->ictrl);
-    }
-    if (cnt)
-    {
-        /* Reset register not cleared by chip reset. */
-#if defined(QL_DEBUG_LEVEL_3)
-        qla1280_print("qla1280_chip_diag: reset register cleared by chip reset\n\r");
-#endif
-        WRT_REG_WORD(&reg->cfg_1, 0);
-
-        /* Reset RISC and disable BIOS which
-        allows RISC to execute out of RAM. */
-        WRT_REG_WORD(&reg->host_cmd, HC_RESET_RISC);
-        WRT_REG_WORD(&reg->host_cmd, HC_RELEASE_RISC);
-        WRT_REG_WORD(&reg->host_cmd, HC_DISABLE_BIOS);
-        data = qla1280_debounce_register(&reg->mailbox0);
-        for (cnt = 6000000; cnt && data == MBS_BUSY; cnt--)
-        {
-            SYS_DELAY(5);
-            data = RD_REG_WORD(&reg->mailbox0);
-        }
-
-        if (cnt)
-        {
-            /* Check product ID of chip */
-#if defined(QL_DEBUG_LEVEL_3)
-            qla1280_print("qla1280_chip_diag: Checking product ID of chip\n\r");
-#endif
-            if (RD_REG_WORD(&reg->mailbox1) != PROD_ID_1 ||
-                (RD_REG_WORD(&reg->mailbox2) != PROD_ID_2 &&
-                RD_REG_WORD(&reg->mailbox2) != PROD_ID_2a) ||
-                RD_REG_WORD(&reg->mailbox3) != PROD_ID_3 ||
-                RD_REG_WORD(&reg->mailbox4) != PROD_ID_4)
-            {
-                printk(KERN_INFO "qla1280: Wrong product ID = 0x%x,0x%x,0x%x,0x%x\n",
-                        RD_REG_WORD(&reg->mailbox1),
-                        RD_REG_WORD(&reg->mailbox2),
-                        RD_REG_WORD(&reg->mailbox3),
-                        RD_REG_WORD(&reg->mailbox4) );
-                status = 1;
-            }
-            else
-            {
-                DEBUG(printk("qla1280_chip_diag: Checking mailboxes of chip\n"));
-                /* Wrap Incoming Mailboxes Test. */
-                mb[0] = MBC_MAILBOX_REGISTER_TEST;
-                mb[1] = 0xAAAA;
-                mb[2] = 0x5555;
-                mb[3] = 0xAA55;
-                mb[4] = 0x55AA;
-                mb[5] = 0xA5A5;
-                mb[6] = 0x5A5A;
-                mb[7] = 0x2525;
-                if (!(status = qla1280_mailbox_command(ha,
-                    (BIT_7|BIT_6|BIT_5|BIT_4|BIT_3|BIT_2|BIT_1|BIT_0),
-                    &mb[0])))
-                {
-                    if (mb[1] != 0xAAAA || mb[2] != 0x5555 ||
-                        mb[3] != 0xAA55 || mb[4] != 0x55AA)
-                        status = 1;
-                    if (mb[5] != 0xA5A5 || mb[6] != 0x5A5A ||
-                        mb[7] != 0x2525)
-                        status = 1;
-                    if( status == 1 )
-                        printk(KERN_INFO "qla1280: Failed mailbox check\n");
-                }
-            }
-        }
-        else
-            status = 1;
-    }
-    else
-        status = 1;
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (status)
-        qla1280_print("qla1280_chip_diag: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        qla1280_print("qla1280_chip_diag: exiting normally\n\r");
+	uint16_t mb[MAILBOX_REGISTER_COUNT];
+	struct device_reg *reg = ha->iobase;
+	int status = 0;
+	int cnt;
+	uint16_t data;
+
+	dprintk(3, "qla1280_chip_diag: testing device at 0x%p \n", &reg->id_l);
+
+	dprintk(1, "scsi(%ld): Verifying chip\n", ha->host_no);
+
+	/* Soft reset chip and wait for it to finish. */
+	WRT_REG_WORD(&reg->ictrl, ISP_RESET);
+	/*
+	 * We can't do a traditional PCI write flush here by reading
+	 * back the register. The card will not respond once the reset
+	 * is in action and we end up with a machine check exception
+	 * instead. Nothing to do but wait and hope for the best.
+	 * A portable pci_write_flush(pdev) call would be very useful here.
+	 */
+	udelay(20);
+	data = qla1280_debounce_register(&reg->ictrl);
+	/*
+	 * Yet another QLogic gem ;-(
+	 */
+	for (cnt = 1000000; cnt && data & ISP_RESET; cnt--) {
+		udelay(5);
+		data = RD_REG_WORD(&reg->ictrl);
+	}
+
+	if (cnt) {
+		/* Reset register cleared by chip reset. */
+		dprintk(3, "qla1280_chip_diag: reset register cleared by "
+			"chip reset\n");
+
+		WRT_REG_WORD(&reg->cfg_1, 0);
+
+		/* Reset RISC and disable BIOS which
+		   allows RISC to execute out of RAM. */
+#if 0
+		WRT_REG_WORD(&reg->host_cmd, HC_RESET_RISC);
+		RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+		WRT_REG_WORD(&reg->host_cmd, HC_RELEASE_RISC);
+		RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+		WRT_REG_WORD(&reg->host_cmd, HC_DISABLE_BIOS);
+#else
+		WRT_REG_WORD(&reg->host_cmd, HC_RESET_RISC |
+			     HC_RELEASE_RISC | HC_DISABLE_BIOS);
 #endif
-    return(status);
+		RD_REG_WORD(&reg->id_l);	/* Flush PCI write */
+		data = qla1280_debounce_register(&reg->mailbox0);
+		/*
+		 * I *LOVE* this code!
+		 */
+		for (cnt = 1000000; cnt && data == MBS_BUSY; cnt--) {
+			udelay(5);
+			data = RD_REG_WORD(&reg->mailbox0);
+		}
+
+		if (cnt) {
+			/* Check product ID of chip */
+			dprintk(3, "qla1280_chip_diag: Checking product "
+				"ID of chip\n");
+
+			if (RD_REG_WORD(&reg->mailbox1) != PROD_ID_1 ||
+			    (RD_REG_WORD(&reg->mailbox2) != PROD_ID_2 &&
+			     RD_REG_WORD(&reg->mailbox2) != PROD_ID_2a) ||
+			    RD_REG_WORD(&reg->mailbox3) != PROD_ID_3 ||
+			    RD_REG_WORD(&reg->mailbox4) != PROD_ID_4) {
+				printk(KERN_INFO "qla1280: Wrong product ID = "
+				       "0x%x,0x%x,0x%x,0x%x\n",
+				       RD_REG_WORD(&reg->mailbox1),
+				       RD_REG_WORD(&reg->mailbox2),
+				       RD_REG_WORD(&reg->mailbox3),
+				       RD_REG_WORD(&reg->mailbox4));
+				status = 1;
+			} else {
+				/*
+				 * Enable ints early!!!
+				 */
+				qla1280_enable_intrs(ha);
+
+				dprintk(1, "qla1280_chip_diag: Checking "
+					"mailboxes of chip\n");
+				/* Wrap Incoming Mailboxes Test. */
+				mb[0] = MBC_MAILBOX_REGISTER_TEST;
+				mb[1] = 0xAAAA;
+				mb[2] = 0x5555;
+				mb[3] = 0xAA55;
+				mb[4] = 0x55AA;
+				mb[5] = 0xA5A5;
+				mb[6] = 0x5A5A;
+				mb[7] = 0x2525;
+				if (!(status = qla1280_mailbox_command(ha,
+								       0xff,
+								       &mb
+								       [0]))) {
+					if (mb[1] != 0xAAAA ||
+					    mb[2] != 0x5555 ||
+					    mb[3] != 0xAA55 ||
+					    mb[4] != 0x55AA ||
+					    mb[5] != 0xA5A5 ||
+					    mb[6] != 0x5A5A ||
+					    mb[7] != 0x2525) {
+						status = 1;
+						printk(KERN_INFO "qla1280: "
+						       "Failed mbox check\n");
+					}
+				}
+			}
+		} else
+			status = 1;
+	} else
+		status = 1;
+
+	if (status)
+		dprintk(2, "qla1280_chip_diag: **** FAILED ****\n");
+	else
+		dprintk(3, "qla1280_chip_diag: exiting normally\n");
+
+	return status;
 }
 
 /*
@@ -2725,173 +2490,142 @@
  * Returns:
  *      0 = success.
  */
-STATIC uint8_t
-qla1280_setup_chip(scsi_qla_host_t *ha)
-{
-    uint8_t      status = 0;
-    uint16_t     risc_address;
-    uint16_t     *risc_code_address;
-    long         risc_code_size;
-    uint16_t     mb[MAILBOX_REGISTER_COUNT];
-#ifdef QLA1280_UNUSED
-    uint8_t	*sp;
-    int i;
-#endif
-    uint16_t     cnt;
-    int          num;
-    uint8_t    *tbuf;
-    u_long     p_tbuf;
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_setup_chip");
-#endif
-
-	if( (tbuf = (uint8_t *)KMALLOC(8000) ) == NULL )
-        {
-            printk("setup_chip: couldn't alloacte memory\n");
-            return(1);
-        }
-        p_tbuf =  VIRT_TO_BUS(tbuf);
-    /* Load RISC code. */
-    /* 
-    risc_address      = ql12_risc_code_addr01;
-    risc_code_address = &ql12_risc_code01[0];
-    risc_code_size    = ql12_risc_code_length01;
-    */
-    risc_address = *QLBoardTbl[ha->devnum].fwstart;  
-    risc_code_address = QLBoardTbl[ha->devnum].fwcode;  
-    risc_code_size    = (long)(*QLBoardTbl[ha->devnum].fwlen & 0xffff);  
-
-    DEBUG(printk("qla1280: DMAing RISC code (%d) words.\n",(int)risc_code_size));
-    DEBUG(sprintf(debug_buff,"qla1280_setup_chip:  Loading RISC code size =(%ld).\n\r",risc_code_size);)
-    DEBUG(qla1280_print(debug_buff));
-    num =0;
-    while (risc_code_size > 0 && !status)
-    {
-        cnt = 2000 >> 1;
-
-        if ( cnt > risc_code_size ) 
-            cnt = risc_code_size;
-
-        DEBUG(sprintf(debug_buff,"qla1280_setup_chip:  loading risc @ =(0x%p),%d,%d(0x%x).\n\r",risc_code_address,cnt,num,risc_address);)
-        DEBUG(qla1280_print(debug_buff));
-        DEBUG(printk("qla1280_setup_chip:  loading risc @ =code=(0x%p),cnt=%d,seg=%d,addr=0x%x\n\r",risc_code_address,cnt,num,risc_address));
-        BCOPY((caddr_t) risc_code_address,(caddr_t) ha->request_ring, (cnt <<1));
-        mb[0] = MBC_LOAD_RAM; 
-        /* mb[0] = MBC_LOAD_RAM_A64; */
-        mb[1] = risc_address;
-        mb[4] = cnt;
-        mb[3] = (uint16_t)  ha->request_dma & 0xffff;
-        mb[2] = (uint16_t) (ha->request_dma >> 16) & 0xffff;
-        mb[7] = (uint16_t) (MS_64BITS(ha->request_dma) & 0xffff);
-        mb[6] = (uint16_t) (MS_64BITS(ha->request_dma) >> 16) & 0xffff;
-        DEBUG(printk("qla1280_setup_chip: op=%d  0x%lx = 0x%4x,0x%4x,0x%4x,0x%4x\n",mb[0],ha->request_dma,mb[6],mb[7],mb[2],mb[3]));
-        if( (status = qla1280_mailbox_command(ha, BIT_4|BIT_3|BIT_2|BIT_1|BIT_0,
-            &mb[0]))  )
-        {
-            printk("Failed to load partial segment of f/w\n");
-            break;
-        }
-        /* dump it back */
+#define DUMP_IT_BACK 0		/* for debug of RISC loading */
+static int
+qla1280_setup_chip(struct scsi_qla_host *ha)
+{
+	int status = 0;
+	uint16_t risc_address;
+	uint16_t *risc_code_address;
+	int risc_code_size;
+	uint16_t mb[MAILBOX_REGISTER_COUNT];
+	uint16_t cnt;
+	int num, i;
+#if DUMP_IT_BACK
+	uint8_t *sp;
+	uint8_t *tbuf;
+	dma_addr_t p_tbuf;
+#endif
+
+	ENTER("qla1280_setup_chip");
+
+	dprintk(1, "scsi(%ld): Setup chip\n", ha->host_no);
+
+#if DUMP_IT_BACK
+	/* get consistent memory allocated for setup_chip */
+	tbuf = pci_alloc_consistent(ha->pdev, 8000, &p_tbuf);
+#endif
+
+	/* Load RISC code. */
+	risc_address = *ql1280_board_tbl[ha->devnum].fwstart;
+	risc_code_address = ql1280_board_tbl[ha->devnum].fwcode;
+	risc_code_size = (int) *ql1280_board_tbl[ha->devnum].fwlen;
+
+	dprintk(1, "qla1280_setup_chip: DMA RISC code (%i) words\n",
+		risc_code_size);
+
+	num = 0;
+	while (risc_code_size > 0 && !status) {
+		int warn __attribute__((unused)) = 0;
+
+		cnt = 2000 >> 1;
+
+		if (cnt > risc_code_size)
+			cnt = risc_code_size;
+
+		dprintk(2, "qla1280_setup_chip:  loading risc @ =(0x%p),"
+			"%d,%d(0x%x)\n",
+			risc_code_address, cnt, num, risc_address);
+		for(i = 0; i < cnt; i++)
+			((uint16_t *)ha->request_ring)[i] =
+				cpu_to_le16(risc_code_address[i]);
+
+		flush_cache_all();
+
+		mb[0] = MBC_LOAD_RAM;
+		mb[1] = risc_address;
+		mb[4] = cnt;
+		mb[3] = ha->request_dma & 0xffff;
+		mb[2] = (ha->request_dma >> 16) & 0xffff;
+		mb[7] = pci_dma_hi32(ha->request_dma) & 0xffff;
+		mb[6] = pci_dma_hi32(ha->request_dma) >> 16;
+		dprintk(2, "qla1280_setup_chip: op=%d  0x%p = 0x%4x,0x%4x,"
+			"0x%4x,0x%4x\n", mb[0], (void *)(long)ha->request_dma,
+			mb[6], mb[7], mb[2], mb[3]);
+		if ((status = qla1280_mailbox_command(ha, BIT_4 | BIT_3 |
+						      BIT_2 | BIT_1 | BIT_0,
+						      &mb[0]))) {
+			printk(KERN_ERR "scsi(%li): Failed to load partial "
+			       "segment of f\n", ha->host_no);
+			break;
+		}
 
-#if 0
-        mb[0] = MBC_DUMP_RAM_A64;
-        mb[1] = risc_address;
-        mb[4] = cnt;
-        mb[3] = (uint16_t)  p_tbuf & 0xffff;
-        mb[2] = (uint16_t) (p_tbuf >> 16) & 0xffff;
-        mb[7] = (uint16_t) (p_tbuf >> 32) & 0xffff;
-        mb[6] = (uint16_t) (p_tbuf >> 48) & 0xffff;
-
-        if( (status = qla1280_mailbox_command(ha, BIT_4|BIT_3|BIT_2|BIT_1|BIT_0,
-            &mb[0]))  )
-        {
-            printk("Failed to dump partial segment of f/w\n");
-            break;
-        }
-        sp =  (uint8_t *)ha->request_ring;
-        for (i = 0; i < (cnt<< 1) ; i++)
-        {
-            if( tbuf[i] != sp[i] )
-            {
-               printk("qla1280 : firmware compare error @ byte (0x%x)\n",i);
-                break;
-            }
-        }
-
-#endif
-        risc_address += cnt;
-        risc_code_size = risc_code_size - cnt;
-        risc_code_address = risc_code_address + cnt;
-        num++;
-    }
-#ifdef QLA1280_UNUSED
-    DEBUG(ql_debug_print = 0;)
-    {
-        for (i = 0; i < ql12_risc_code_length01; i++)
-        {
-            mb[0] = 0x4;
-            mb[1] = ql12_risc_code_addr01 + i;
-            mb[2] = ql12_risc_code01[i];
-
-            status = qla1280_mailbox_command(ha, BIT_2|BIT_1|BIT_0,
-                    &mb[0]);
-            if (status)
-            {
-                printk("qla1280 : firmware load failure\n");
-                break;
-            }
-
-            mb[0] = 0x5;
-            mb[1] = ql12_risc_code_addr01 + i;
-            mb[2] = 0;
-
-            status = qla1280_mailbox_command(ha, BIT_2|BIT_1|BIT_0,
-                    &mb[0]);
-            if (status)
-            {
-                printk("qla1280 : firmware dump failure\n");
-                break;
-            }
-            if( mb[2] != ql12_risc_code01[i] )
-                printk("qla1280 : firmware compare error @ (0x%x)\n",ql12_risc_code_addr01+i);
-        }
-    }
-    DEBUG(ql_debug_print = 1;)
-#endif
-
-    /* Verify checksum of loaded RISC code. */
-    if (!status)
-    {
-        DEBUG(printk("qla1280_setup_chip: Verifying checksum of loaded RISC code.\n");)
-        mb[0] = MBC_VERIFY_CHECKSUM;
-        /* mb[1] = ql12_risc_code_addr01; */
-        mb[1] = *QLBoardTbl[ha->devnum].fwstart;  
-        
-        if (!(status = qla1280_mailbox_command(ha, BIT_1|BIT_0, &mb[0])))
-        {
-            /* Start firmware execution. */
-            DEBUG(qla1280_print("qla1280_setup_chip: start firmware running.\n\r");)
-            mb[0] = MBC_EXECUTE_FIRMWARE;
-            /* mb[1] = ql12_risc_code_addr01; */
-            mb[1] = *QLBoardTbl[ha->devnum].fwstart;  
-            qla1280_mailbox_command(ha, BIT_1|BIT_0, &mb[0]);
-        }
-        else
-            printk("qla1280_setup_chip: Failed checksum.\n");
-    }
-
-	KMFREE(tbuf,8000);
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (status)
-        qla1280_print("qla1280_setup_chip: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        LEAVE("qla1280_setup_chip");
+#if DUMP_IT_BACK
+		mb[0] = MBC_DUMP_RAM;
+		mb[1] = risc_address;
+		mb[4] = cnt;
+		mb[3] = p_tbuf & 0xffff;
+		mb[2] = (p_tbuf >> 16) & 0xffff;
+		mb[7] = pci_dma_hi32(p_tbuf) & 0xffff;
+		mb[6] = pci_dma_hi32(p_tbuf) >> 16;
+
+		if ((status = qla1280_mailbox_command(ha,
+						      BIT_4 | BIT_3 | BIT_2 |
+						      BIT_1 | BIT_0,
+						      &mb[0]))) {
+			printk(KERN_ERR
+			       "Failed to dump partial segment of f/w\n");
+			break;
+		}
+		sp = (uint8_t *)ha->request_ring;
+		for (i = 0; i < (cnt << 1); i++) {
+			if (tbuf[i] != sp[i] && warn++ < 10) {
+				printk(KERN_ERR "qla1280_setup_chip: FW "
+				       "compare error @ byte(0x%x) loop#=%x\n",
+				       i, num);
+				printk(KERN_ERR "setup_chip: FWbyte=%x  "
+				       "FWfromChip=%x\n", sp[i], tbuf[i]);
+				/*break; */
+			}
+		}
+#endif
+		risc_address += cnt;
+		risc_code_size = risc_code_size - cnt;
+		risc_code_address = risc_code_address + cnt;
+		num++;
+	}
+
+	/* Verify checksum of loaded RISC code. */
+	if (!status) {
+		dprintk(1, "qla1280_setup_chip: Verifying checksum of "
+			"loaded RISC code.\n");
+		mb[0] = MBC_VERIFY_CHECKSUM;
+		/* mb[1] = ql12_risc_code_addr01; */
+		mb[1] = *ql1280_board_tbl[ha->devnum].fwstart;
+
+		if (!(status =
+		      qla1280_mailbox_command(ha, BIT_1 | BIT_0, &mb[0]))) {
+			/* Start firmware execution. */
+			dprintk(1,
+				"qla1280_setup_chip: start firmware running.\n");
+			mb[0] = MBC_EXECUTE_FIRMWARE;
+			mb[1] = *ql1280_board_tbl[ha->devnum].fwstart;
+			qla1280_mailbox_command(ha, BIT_1 | BIT_0, &mb[0]);
+		} else
+			printk(KERN_ERR "scsi(%li): qla1280_setup_chip: "
+			       "Failed checksum\n", ha->host_no);
+	}
+
+#if DUMP_IT_BACK
+	/* free consistent memory allocated for setup_chip */
+	pci_free_consistent(ha->pdev, 8000, tbuf, p_tbuf);
 #endif
-    return(status);
+
+	if (status)
+		dprintk(2, "qla1280_setup_chip: **** FAILED ****\n");
+
+	LEAVE("qla1280_setup_chip");
+	return status;
 }
 
 /*
@@ -2907,61 +2641,54 @@
  * Returns:
  *      0 = success.
  */
-STATIC uint8_t
-qla1280_init_rings(scsi_qla_host_t *ha)
+static int
+qla1280_init_rings(struct scsi_qla_host *ha)
 {
-    uint8_t     status = 0;
-    uint16_t    cnt;
-    uint16_t    mb[MAILBOX_REGISTER_COUNT];
-
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_init_rings");
-#endif
-    /* Clear outstanding commands array. */
-    for (cnt = 0; cnt < MAX_OUTSTANDING_COMMANDS; cnt++)
-        ha->outstanding_cmds[cnt] = 0;
-
-    /* Initialize request queue. */
-    ha->request_ring_ptr = ha->request_ring;
-    ha->req_ring_index   = 0;
-    ha->req_q_cnt        = REQUEST_ENTRY_CNT;
-    /* mb[0] = MBC_INIT_REQUEST_QUEUE; */
-    mb[0] = MBC_INIT_REQUEST_QUEUE_A64;
-    mb[1] = REQUEST_ENTRY_CNT;
-    mb[3] = (uint16_t)LS_64BITS(ha->request_dma);
-    mb[2] = (uint16_t)( LS_64BITS(ha->request_dma) >> 16);
-    mb[4] = 0;
-    mb[7] = (uint16_t)MS_64BITS(ha->request_dma);
-    mb[6] = (uint16_t)( MS_64BITS(ha->request_dma) >> 16);
-    if (!(status = qla1280_mailbox_command(ha,
-        BIT_7|BIT_6|BIT_4|BIT_3|BIT_2|BIT_1|BIT_0,
-        &mb[0])))
-    {
-        /* Initialize response queue. */
-        ha->response_ring_ptr = ha->response_ring;
-        ha->rsp_ring_index    = 0;
-        /* mb[0] = MBC_INIT_RESPONSE_QUEUE; */
-        mb[0] = MBC_INIT_RESPONSE_QUEUE_A64;
-        mb[1] = RESPONSE_ENTRY_CNT;
-        mb[3] = (uint16_t)LS_64BITS(ha->response_dma);
-        mb[2] = (uint16_t)(LS_64BITS(ha->response_dma) >> 16);
-        mb[5] = 0;
-        mb[7] = (uint16_t)MS_64BITS(ha->response_dma);
-        mb[6] = (uint16_t)(MS_64BITS(ha->response_dma) >> 16);
-        status = qla1280_mailbox_command(ha,
-                BIT_7|BIT_6|BIT_5|BIT_3|BIT_2|BIT_1|BIT_0,
-                &mb[0]);
-    }
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    if (status)
-        qla1280_print("qla1280_init_rings: **** FAILED ****\n\r");
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-    else
-        LEAVE("qla1280_init_rings");
-#endif
-    return(status);
+	uint16_t mb[MAILBOX_REGISTER_COUNT];
+	int status = 0;
+
+	ENTER("qla1280_init_rings");
+
+	/* Clear outstanding commands array. */
+	memset(ha->outstanding_cmds, 0,
+	       sizeof(struct srb *) * MAX_OUTSTANDING_COMMANDS);
+
+	/* Initialize request queue. */
+	ha->request_ring_ptr = ha->request_ring;
+	ha->req_ring_index = 0;
+	ha->req_q_cnt = REQUEST_ENTRY_CNT;
+	/* mb[0] = MBC_INIT_REQUEST_QUEUE; */
+	mb[0] = MBC_INIT_REQUEST_QUEUE_A64;
+	mb[1] = REQUEST_ENTRY_CNT;
+	mb[3] = ha->request_dma & 0xffff;
+	mb[2] = (ha->request_dma >> 16) & 0xffff;
+	mb[4] = 0;
+	mb[7] = pci_dma_hi32(ha->request_dma) & 0xffff;
+	mb[6] = pci_dma_hi32(ha->request_dma) >> 16;
+	if (!(status = qla1280_mailbox_command(ha, BIT_7 | BIT_6 | BIT_4 |
+					       BIT_3 | BIT_2 | BIT_1 | BIT_0,
+					       &mb[0]))) {
+		/* Initialize response queue. */
+		ha->response_ring_ptr = ha->response_ring;
+		ha->rsp_ring_index = 0;
+		/* mb[0] = MBC_INIT_RESPONSE_QUEUE; */
+		mb[0] = MBC_INIT_RESPONSE_QUEUE_A64;
+		mb[1] = RESPONSE_ENTRY_CNT;
+		mb[3] = ha->response_dma & 0xffff;
+		mb[2] = (ha->response_dma >> 16) & 0xffff;
+		mb[5] = 0;
+		mb[7] = pci_dma_hi32(ha->response_dma) & 0xffff;
+		mb[6] = pci_dma_hi32(ha->response_dma) >> 16;
+		status = qla1280_mailbox_command(ha, BIT_7 | BIT_6 | BIT_5 |
+						 BIT_3 | BIT_2 | BIT_1 | BIT_0,
+						 &mb[0]);
+	}
+
+	if (status)
+		dprintk(2, "qla1280_init_rings: **** FAILED ****\n");
+
+	LEAVE("qla1280_init_rings");
+	return status;
 }
 
 /*
